//=========================================
//
//RPBGAME 1.0 FOR Linux                         by adie
//							A!die Software Studio
//						     http://adie2001.8u8.com
//  CopyRight(C)   All right reseved          2003-02-23
//
//=========================================

#include <X11/Xlib.h>	//Xlib 
#include <X11/keysym.h>	//̴
#include <X11/Xutil.h>	//չ
#include <X11/Xos.h>	//չ
#include <iostream>	//ն
#include <stdlib.h>	//need exit()

//=================================
//	ԭ
//=================================

bool RB_drawborder();
bool RB_Initblock();
bool draw_rectangle(int row,int col);
bool clean_rectangle(int row,int col);
bool AddBlock(int shape,int crow,int ccol);
bool SubBlock(int shape,int crow,int ccol);
bool test(int shape,int crow,int ccol);
bool draw_next(int c1,int c2,int c3,int c4);
bool DealKeyMessage(KeySym key);
bool DOWN();
bool LEFT();
bool RIGHT();
bool TURN();
bool FDOWN();
void viewvalue();
void viewnext(int shape);
void kill(int row);
int enter_game();
int AddMark();


using namespace std;


//=================================
//	ڲ
//=================================
Display *display; //򿪴ڵȫʾ
Window win;       //򿪴ڵȫָ
GC gc;		      //豸


//=================================
//	
//=================================
bool body[29][19];
bool playing=false;	//ǷʼϷ
int shape1;
int shape2;
int ccrow;
int cccol;
int speed=1;
int mark=1;
int his=0;


int main()
{

	srandom(time(NULL));
	 /*ʼ*/
	for(int j=0;j<=18;j++)
	{
	   body[0][j]=true;
	   body[26][j]=true;
	   body[27][j]=true;
	   body[28][j]=true;
	}
	 for(int i=0;i<=28;i++)
	{
	   body[i][0]=1;
	   body[i][16]=1;
	   body[i][17]=1;
	   body[i][18]=1;
	}
	for(int i=1;i<=25;i++)
		for(int j=1;j<=15;j++)
			body[i][j]=false;

	display=XOpenDisplay(NULL);
	if(display==NULL)
	{
		cerr<<"Cannot open to display!"<<endl;
		exit(1);
	}

	int intScreenNum=DefaultScreen(display);
	int intDisplayWidth=DisplayWidth(display,intScreenNum);
	int intDisplayHeight=DisplayHeight(display,intScreenNum);
	int intWidth=440;
	int intHeight=600;
	int intXPos=0;
	int intYPos=0;

	int intBlackColor=BlackPixel(display,intScreenNum);
	int intWhiteColor=WhitePixel(display,intScreenNum);

	win=XCreateSimpleWindow(display,DefaultRootWindow(display),
					intXPos,intYPos,intWidth,intHeight,0,intBlackColor,intWhiteColor);
	XStoreName(display,win,"RPBGame 1.0 For Linux");

	XMapWindow(display,win);

	long event_mask=KeyPressMask|StructureNotifyMask|ExposureMask|ButtonPressMask;
	XSelectInput(display,win,event_mask);
	gc=XCreateGC(display,win,0,NULL);

	KeySym key;
	XComposeStatus cstat;
	char keyname[32]="";

	XEvent event;
	bool done=false;
	while(!done)
	{
		if(XCheckMaskEvent(display,event_mask,&event))
		{
			switch(event.type)
			{
				case Expose:
					RB_drawborder();
					RB_Initblock();
					viewvalue();
					break;
				case KeyPress:
					XLookupString(&event.xkey,keyname,32,&key,&cstat);
					done=DealKeyMessage(key);
					break;
				case ButtonPress:
					if(event.xbutton.button==1) LEFT();
					if(event.xbutton.button==3) RIGHT();
					break;
				default:
					break;
			}
		}
		else
		{
			if(playing)
			{
				DOWN();
				for(unsigned long int i=0;i<=9000000*(20-speed);i++);
				viewvalue();
			}
		}
	}

	XCloseDisplay(display);
	return 0;
}

bool DealKeyMessage(KeySym key)
{
	switch(key)
	{
		case XK_Escape:
			return(true);
			break;
		case XK_Return:
			if(playing==false)
			{
				playing=true;
				shape1=random()%19+1;
				enter_game();
			}
			break;
		case XK_a:
		case XK_Left:
			if(playing==true)
			{
				LEFT();
				for(unsigned long int i=0;i<=800000*(20-speed);i++);
			}
			break;
		case XK_f:
		case XK_Right:
			if(playing==true)
			{
				RIGHT();
				for(unsigned long int i=0;i<=800000*(20-speed);i++);
			}
			break;
		case XK_g:
		case XK_t:
			if(playing==true)
			{
				TURN();
				for(unsigned long int i=0;i<=800000*(20-speed);i++);
			}
			break;
		case XK_Down:
		case XK_space:
			if(playing)
				FDOWN();
			break;
		default:
			break;
	}
	return(false);
}

int  enter_game()
{
	ccrow=2;
	cccol=6;
	if(!AddBlock(shape1,ccrow,cccol)) return(-1);
	shape2=random()%19+1;
	viewnext(shape2);
}

bool DOWN()
{
	 SubBlock(shape1,ccrow,cccol);
	 if(test(shape1,ccrow+1,cccol))
	{               /*һ*/
		ccrow++;
		AddBlock(shape1,ccrow,cccol);
		return(true);
	}
	else
	 {                                /*...*/
		AddBlock(shape1,ccrow,cccol);     /*жǷĳ*/
		int time=AddMark();
		 if(time!=0)
		{                             /*ӷ*/
			 mark=mark+10*time;
			if(mark-his>500)            /*Ƿ*/
			{
				speed++;
				if(speed>20) speed=1;
				his+=500;
			}
			viewvalue();
		}
		AddBlock(shape1,ccrow,cccol);
		shape1=shape2;   /*һ*/
		if(!enter_game())  playing=false;
		return(false);
	}
}

bool FDOWN()
{
	for(int i=0;i<5&&DOWN();i++);
	return(true);
}

bool LEFT()
{
	   SubBlock(shape1,ccrow,cccol);
	   if(test(shape1,ccrow,cccol-1)) cccol--;
	   AddBlock(shape1,ccrow,cccol);
}

bool RIGHT()
{
	   SubBlock(shape1,ccrow,cccol);
	   if(test(shape1,ccrow,cccol+1)) cccol++;
	   AddBlock(shape1,ccrow,cccol);
}

bool TURN()
{
	int shape3;
	   switch(shape1)
	    {
	     case 1: case 3: case 4: case 5: case 7: case 8: case 9:
	     case 11: case 12: case 13: case 16: case 18:
	      shape3=shape1+1;
	      break;
	     case 2: shape3=1;break;
	     case 6: shape3=3;break;
	     case 10: shape3=7;break;
	     case 14: shape3=11;break;
	     case 15: shape3=15;break;
	     case 17: case 19: shape3=shape1-1; break;
	     default: break;
	    }    /*жִеĲǷɹ*/
	    SubBlock(shape1,ccrow,cccol);
	    if(test(shape3,ccrow,cccol)) shape1=shape3;
	    AddBlock(shape1,ccrow,cccol);
}

void viewvalue()
{
	char show[14];
	XDrawString(display,win,gc,340,170,"**************",14);
	XDrawString(display,win,gc,340,200,"  GAME   VAR  ",14);
	sprintf(show,"MARK: %d",mark);
	XDrawString(display,win,gc,340,220,"                   ",20);
	XDrawString(display,win,gc,340,220,show,strlen(show));
	sprintf(show,"SPEED: %d",speed);
	XDrawString(display,win,gc,340,240,"                  ",20);
	XDrawString(display,win,gc,340,240,show,strlen(show));
	if(playing) XDrawString(display,win,gc,343,270,"PLAYING.....",12);
	XDrawString(display,win,gc,340,300,"**************",14);
	XDrawString(display,win,gc,340,320," HELP    INFO ",14);
	XDrawString(display,win,gc,340,340,"START: [Enter]",14);
	XDrawString(display,win,gc,340,360,"QUIT:    [ESC]",14);
	XDrawString(display,win,gc,340,380,"LEFT:        a",14);
	XDrawString(display,win,gc,340,400," lbutton  <---",14);
	XDrawString(display,win,gc,340,420,"RIGHT:      f  ",14);
	XDrawString(display,win,gc,340,440," rbutton  --->",14);
	XDrawString(display,win,gc,340,460,"TURN:   g   t ",14);
	XDrawString(display,win,gc,340,480,"DOWN:    SPACE ",14);
	XDrawString(display,win,gc,340,500,"         \\|/   ",14);
	XDrawString(display,win,gc,340,520,"**************",14);
}

bool RB_drawborder()
{
	XDrawString(display,win,gc,85,20,"Russia Block Plan Game 1.0  For Linux",37);
	XDrawString(display,win,gc,220,35,"A!die Software Studio",21);
	XDrawString(display,win,gc,215,50,"http://adie2001.8u8.com",23);
	int intBlackColor=BlackPixel(display,DefaultScreen(display));
	XSetForeground(display,gc,intBlackColor);
	XDrawRectangle(display,win,gc,18,58,303,503);
	XDrawRectangle(display,win,gc,338,58,83,83);
	return(true);
}

bool RB_Initblock()
{
	for(int row=1;row<=25;row++)
		for(int col=1;col<=15;col++)
			if(body[row][col]==true)
				draw_rectangle(row,col);
	return(true);
}

bool draw_rectangle(int row,int col)
{
	int intBlackColor=BlackPixel(display,DefaultScreen(display));
	XSetForeground(display,gc,intBlackColor);
	XFillRectangle(display,win,gc,20*col,40+20*row,19,19);
	return(true);
}

bool clean_rectangle(int row,int col)
{
	int intWhiteColor=WhitePixel(display,DefaultScreen(display));
	XSetForeground(display,gc,intWhiteColor);
	XFillRectangle(display,win,gc,20*col,40+20*row,19,19);
	return(true);
}


bool AddBlock(int shape,int crow,int ccol) /*ָλûshapeָķ,ʾfalse*/
{
 switch(shape)
  {
    case 1:
	 if(body[crow][ccol]+body[crow][ccol+1]+body[crow][ccol+2]+
	    body[crow][ccol+3]>=1)
           return(false);    /*жܷʾͬ*/

	 body[crow][ccol]=1,body[crow][ccol+1]=1,body[crow][ccol+2]=1,body[crow][ccol+3]=1;
                                 /*ѶӦԪ1ͬ*/
	 draw_rectangle(crow,ccol);           /*ͬ*/
	 draw_rectangle(crow,ccol+1);
	 draw_rectangle(crow,ccol+2);
	 draw_rectangle(crow,ccol+3);
	 return(true);

     case 2:
         if(body[crow][ccol]+body[crow+1][ccol]+body[crow+2][ccol]+
	    body[crow+3][ccol]>=1)
           return(false);

	 body[crow][ccol]=1,body[crow+1][ccol]=1,body[crow+2][ccol]=1,body[crow+3][ccol]=1;
	 draw_rectangle(crow,ccol);
	 draw_rectangle(crow+1,ccol);
	 draw_rectangle(crow+2,ccol);
	 draw_rectangle(crow+3,ccol);
	 return(true);

     case 3:
         if(body[crow][ccol]+body[crow+1][ccol]+body[crow+1][ccol+1]+
	    body[crow+1][ccol+2]>=1)
          return(false);

	 body[crow][ccol]=1,body[crow+1][ccol]=1,body[crow+1][ccol+1]=1,body[crow+1][ccol+2]=1;
	 draw_rectangle(crow,ccol);
	 draw_rectangle(crow+1,ccol);
	 draw_rectangle(crow+1,ccol+1);
	 draw_rectangle(crow+1,ccol+2);
	 return(true);

     case 4:
         if(body[crow][ccol]+body[crow][ccol+1]+body[crow+1][ccol]+
	    body[crow+2][ccol]>=1)
          return(false);

	 body[crow][ccol]=1,body[crow][ccol+1]=1,body[crow+1][ccol]=1,body[crow+2][ccol]=1;
	 draw_rectangle(crow,ccol);
	 draw_rectangle(crow,ccol+1);
	 draw_rectangle(crow+1,ccol);
	 draw_rectangle(crow+2,ccol);
	 return(true);

     case 5:
         if(body[crow][ccol]+body[crow][ccol+1]+body[crow][ccol+2]+
	    body[crow+1][ccol+2]>=1)
           return(false);


	 body[crow][ccol]=1,body[crow][ccol+1]=1,body[crow][ccol+2]=1,body[crow+1][ccol+2]=1;
	 draw_rectangle(crow,ccol);
	 draw_rectangle(crow,ccol+1);
	 draw_rectangle(crow,ccol+2);
	 draw_rectangle(crow+1,ccol+2);
	 return(true);

     case 6:
         if(body[crow][ccol]+body[crow+1][ccol]+body[crow+2][ccol]+
	    body[crow+2][ccol-1]>=1)
	    return(false);

	 body[crow][ccol]=1,body[crow+1][ccol]=1,body[crow+2][ccol]=1,body[crow+2][ccol-1]=1;
	 draw_rectangle(crow,ccol);
	 draw_rectangle(crow+1,ccol);
	 draw_rectangle(crow+2,ccol);
	 draw_rectangle(crow+2,ccol-1);
	 return(true);

     case 7:
         if(body[crow][ccol]+body[crow][ccol+1]+body[crow][ccol+2]+
	    body[crow-1][ccol+2]>=1)
	  return(false);

	 body[crow][ccol]=1,body[crow][ccol+1]=1,body[crow][ccol+2]=1,body[crow-1][ccol+2]=1;
	 draw_rectangle(crow,ccol);
	 draw_rectangle(crow,ccol+1);
	 draw_rectangle(crow,ccol+2);
	 draw_rectangle(crow-1,ccol+2);
	 return(true);

     case 10:
         if(body[crow][ccol]+body[crow][ccol+1]+body[crow+1][ccol+1]+
	    body[crow+2][ccol+1]>=1)
	       return(false);

	 body[crow][ccol]=1,body[crow][ccol+1]=1,body[crow+1][ccol+1]=1,body[crow+2][ccol+1]=1;
	 draw_rectangle(crow,ccol);
	 draw_rectangle(crow,ccol+1);
	 draw_rectangle(crow+1,ccol+1);
	 draw_rectangle(crow+2,ccol+1);
	 return(true);

     case 9:
         if(body[crow][ccol]+body[crow][ccol+1]+body[crow][ccol+2]+
	    body[crow+1][ccol]>=1)
	  return(false);

	 body[crow][ccol]=1,body[crow][ccol+1]=1,body[crow][ccol+2]=1,body[crow+1][ccol]=1;
	 draw_rectangle(crow,ccol);
	 draw_rectangle(crow,ccol+1);
	 draw_rectangle(crow,ccol+2);
	 draw_rectangle(crow+1,ccol);
	 return(true);

     case 8:
         if(body[crow][ccol]+body[crow+1][ccol]+body[crow+2][ccol]+
	    body[crow+2][ccol+1]>=1)
	     return(false);

	 body[crow][ccol]=1,body[crow+1][ccol]=1,body[crow+2][ccol]=1,body[crow+2][ccol+1]=1;
	 draw_rectangle(crow,ccol);
	 draw_rectangle(crow+1,ccol);
	 draw_rectangle(crow+2,ccol);
	 draw_rectangle(crow+2,ccol+1);
	 return(true);

     case 11:
         if(body[crow][ccol]+body[crow+1][ccol]+body[crow+1][ccol+1]+
	    body[crow+1][ccol-1]>=1)
	     return(false);

	 body[crow][ccol]=1,body[crow+1][ccol]=1,body[crow+1][ccol+1]=1,body[crow+1][ccol-1]=1;
	 draw_rectangle(crow,ccol);
	 draw_rectangle(crow+1,ccol);
	 draw_rectangle(crow+1,ccol+1);
	 draw_rectangle(crow+1,ccol-1);
	 return(true);

     case 12:
         if(body[crow][ccol]+body[crow+1][ccol]+body[crow+1][ccol+1]+
	    body[crow+2][ccol]>=1)
	     return(false);

	 body[crow][ccol]=1,body[crow+1][ccol]=1,body[crow+1][ccol+1]=1,body[crow+2][ccol]=1;
	 draw_rectangle(crow,ccol);
	 draw_rectangle(crow+1,ccol);
	 draw_rectangle(crow+1,ccol+1);
	 draw_rectangle(crow+2,ccol);
	 return(true);

     case 13:
         if(body[crow][ccol]+body[crow][ccol+1]+body[crow][ccol+2]+
	    body[crow+1][ccol+1]>=1)
	    return(false);

	 body[crow][ccol]=1,body[crow][ccol+1]=1,body[crow][ccol+2]=1,body[crow+1][ccol+1]=1;
	 draw_rectangle(crow,ccol);
	 draw_rectangle(crow,ccol+1);
	 draw_rectangle(crow,ccol+2);
	 draw_rectangle(crow+1,ccol+1);
	 return(true);

     case 14:
         if(body[crow][ccol]+body[crow+1][ccol]+body[crow+2][ccol]+
	    body[crow+1][ccol-1]>=1)
	     return(false);

	 body[crow][ccol]=1,body[crow+1][ccol]=1,body[crow+2][ccol]=1,body[crow+1][ccol-1]=1;
	 draw_rectangle(crow,ccol);
	 draw_rectangle(crow+1,ccol);
	 draw_rectangle(crow+2,ccol);
	 draw_rectangle(crow+1,ccol-1);
	 return(true);

     case 15:
         if(body[crow][ccol]+body[crow][ccol+1]+body[crow+1][ccol]+
	    body[crow+1][ccol+1]>=1)
	     return(false);

	 body[crow][ccol]=1,body[crow][ccol+1]=1,body[crow+1][ccol]=1,body[crow+1][ccol+1]=1;
	 draw_rectangle(crow,ccol);
	 draw_rectangle(crow,ccol+1);
	 draw_rectangle(crow+1,ccol);
	 draw_rectangle(crow+1,ccol+1);
	 return(true);

     case 16:
         if(body[crow][ccol]+body[crow+1][ccol]+body[crow+1][ccol+1]+
	    body[crow+2][ccol+1]>=1)
	     return(false);

	 body[crow][ccol]=1,body[crow+1][ccol]=1,body[crow+1][ccol+1]=1,body[crow+2][ccol+1]=1;
	 draw_rectangle(crow,ccol);
	 draw_rectangle(crow+1,ccol);
	 draw_rectangle(crow+1,ccol+1);
	 draw_rectangle(crow+2,ccol+1);
	 return(true);

     case 17:
         if(body[crow][ccol]+body[crow][ccol+1]+body[crow+1][ccol-1]+
	    body[crow+1][ccol]>=1)
	     return(false);

	 body[crow][ccol]=1,body[crow][ccol+1]=1,body[crow+1][ccol]=1,body[crow+1][ccol-1]=1;
	 draw_rectangle(crow,ccol);
	 draw_rectangle(crow,ccol+1);
	 draw_rectangle(crow+1,ccol-1);
	 draw_rectangle(crow+1,ccol);
	 return(true);

     case 18:
         if(body[crow][ccol]+body[crow+1][ccol]+body[crow][ccol+1]+
	    body[crow-1][ccol+1]>=1)
	     return(false);

	 body[crow][ccol]=1,body[crow+1][ccol]=1,body[crow][ccol+1]=1,body[crow-1][ccol+1]=1;
	 draw_rectangle(crow,ccol);
	 draw_rectangle(crow+1,ccol);
	 draw_rectangle(crow,ccol+1);
	 draw_rectangle(crow-1,ccol+1);
	 return(true);

     case 19:
         if(body[crow][ccol]+body[crow][ccol+1]+body[crow+1][ccol+2]+
	    body[crow+1][ccol+1]>=1)
	     return(false);

	 body[crow][ccol]=1,body[crow][ccol+1]=1,body[crow+1][ccol+2]=1,body[crow+1][ccol+1]=1;
	 draw_rectangle(crow,ccol);
	 draw_rectangle(crow,ccol+1);
	 draw_rectangle(crow+1,ccol+2);
	 draw_rectangle(crow+1,ccol+1);
	 return(true);

     default:return(false);

  }
}

bool SubBlock(int shape,int crow,int ccol)  /*ָ״ָķ飬ʧܷfalse*/
{
 switch(shape)
  {
    case 1:
	 if(body[crow][ccol]+body[crow][ccol+1]+body[crow][ccol+2]+
	    body[crow][ccol+3]!=4)
	     return(false);

	 body[crow][ccol]=0,body[crow][ccol+1]=0,body[crow][ccol+2]=0,body[crow][ccol+3]=0;
	 clean_rectangle(crow,ccol);
	 clean_rectangle(crow,ccol+1);
	 clean_rectangle(crow,ccol+2);
	 clean_rectangle(crow,ccol+3);
	 return(true);

     case 2:
         if(body[crow][ccol]+body[crow+1][ccol]+body[crow+2][ccol]+
	    body[crow+3][ccol]!=4)
	     return(false);

	 body[crow][ccol]=0,body[crow+1][ccol]=0,body[crow+2][ccol]=0,body[crow+3][ccol]=0;
	 clean_rectangle(crow,ccol);
	 clean_rectangle(crow+1,ccol);
	 clean_rectangle(crow+2,ccol);
	 clean_rectangle(crow+3,ccol);
	 return(true);

     case 3:
         if(body[crow][ccol]+body[crow+1][ccol]+body[crow+1][ccol+1]+
	    body[crow+1][ccol+2]!=4)
	     return(false);

	 body[crow][ccol]=0,body[crow+1][ccol]=0,body[crow+1][ccol+1]=0,body[crow+1][ccol+2]=0;
	 clean_rectangle(crow,ccol);
	 clean_rectangle(crow+1,ccol);
	 clean_rectangle(crow+1,ccol+1);
	 clean_rectangle(crow+1,ccol+2);
	 return(true);

     case 4:
         if(body[crow][ccol]+body[crow][ccol+1]+body[crow+1][ccol]+
	    body[crow+2][ccol]!=4)
	     return(false);

	 body[crow][ccol]=0,body[crow][ccol+1]=0,body[crow+1][ccol]=0,body[crow+2][ccol]=0;
	 clean_rectangle(crow,ccol);
	 clean_rectangle(crow,ccol+1);
	 clean_rectangle(crow+1,ccol);
	 clean_rectangle(crow+2,ccol);
	 return(true);

     case 5:
         if(body[crow][ccol]+body[crow][ccol+1]+body[crow][ccol+2]+
	    body[crow+1][ccol+2]!=4)
	     return(false);

	 body[crow][ccol]=0,body[crow][ccol+1]=0,body[crow][ccol+2]=0,body[crow+1][ccol+2]=0;
	 clean_rectangle(crow,ccol);
	 clean_rectangle(crow,ccol+1);
	 clean_rectangle(crow,ccol+2);
	 clean_rectangle(crow+1,ccol+2);
	 return(true);

     case 6:
         if(body[crow][ccol]+body[crow+1][ccol]+body[crow+2][ccol]+
	    body[crow+2][ccol-1]!=4)
	     return(false);

	 body[crow][ccol]=0,body[crow+1][ccol]=0,body[crow+2][ccol]=0,body[crow+2][ccol-1]=0;
	 clean_rectangle(crow,ccol);
	 clean_rectangle(crow+1,ccol);
	 clean_rectangle(crow+2,ccol);
	 clean_rectangle(crow+2,ccol-1);
	 return(true);

     case 7:
         if(body[crow][ccol]+body[crow][ccol+1]+body[crow][ccol+2]+
	    body[crow-1][ccol+2]!=4)
	     return(false);

	 body[crow][ccol]=0,body[crow][ccol+1]=0,body[crow][ccol+2]=0,body[crow-1][ccol+2]=0;
	 clean_rectangle(crow,ccol);
	 clean_rectangle(crow,ccol+1);
	 clean_rectangle(crow,ccol+2);
	 clean_rectangle(crow-1,ccol+2);
	 return(true);

     case 10:
         if(body[crow][ccol]+body[crow][ccol+1]+body[crow+1][ccol+1]+
	    body[crow+2][ccol+1]!=4)
	     return(false);

	 body[crow][ccol]=0,body[crow][ccol+1]=0,body[crow+1][ccol+1]=0,body[crow+2][ccol+1]=0;
	 clean_rectangle(crow,ccol);
	 clean_rectangle(crow,ccol+1);
	 clean_rectangle(crow+1,ccol+1);
	 clean_rectangle(crow+2,ccol+1);
	 return(true);

     case 9:
         if(body[crow][ccol]+body[crow][ccol+1]+body[crow][ccol+2]+
	    body[crow+1][ccol]!=4)
	     return(false);

	 body[crow][ccol]=0,body[crow][ccol+1]=0,body[crow][ccol+2]=0,body[crow+1][ccol]=0;
	 clean_rectangle(crow,ccol);
	 clean_rectangle(crow,ccol+1);
	 clean_rectangle(crow,ccol+2);
	 clean_rectangle(crow+1,ccol);
	 return(true);

     case 8:
         if(body[crow][ccol]+body[crow+1][ccol]+body[crow+2][ccol]+
	    body[crow+2][ccol+1]!=4)
	     return(false);

	 body[crow][ccol]=0,body[crow+1][ccol]=0,body[crow+2][ccol]=0,body[crow+2][ccol+1]=0;
	 clean_rectangle(crow,ccol);
	 clean_rectangle(crow+1,ccol);
	 clean_rectangle(crow+2,ccol);
	 clean_rectangle(crow+2,ccol+1);
	 return(true);

     case 11:
         if(body[crow][ccol]+body[crow+1][ccol]+body[crow+1][ccol+1]+
	    body[crow+1][ccol-1]!=4)
	     return(false);

	 body[crow][ccol]=0,body[crow+1][ccol]=0,body[crow+1][ccol+1]=0,body[crow+1][ccol-1]=0;
	 clean_rectangle(crow,ccol);
	 clean_rectangle(crow+1,ccol);
	 clean_rectangle(crow+1,ccol+1);
	 clean_rectangle(crow+1,ccol-1);
	 return(true);

     case 12:
         if(body[crow][ccol]+body[crow+1][ccol]+body[crow+1][ccol+1]+
	    body[crow+2][ccol]!=4)
	     return(false);

	 body[crow][ccol]=0,body[crow+1][ccol]=0,body[crow+1][ccol+1]=0,body[crow+2][ccol]=0;
	 clean_rectangle(crow,ccol);
	 clean_rectangle(crow+1,ccol);
	 clean_rectangle(crow+1,ccol+1);
	 clean_rectangle(crow+2,ccol);
	 return(true);

     case 13:
         if(body[crow][ccol]+body[crow][ccol+1]+body[crow][ccol+2]+
	    body[crow+1][ccol+1]!=4)
	     return(false);

	 body[crow][ccol]=0,body[crow][ccol+1]=0,body[crow][ccol+2]=0,body[crow+1][ccol+1]=0;
	 clean_rectangle(crow,ccol);
	 clean_rectangle(crow,ccol+1);
	 clean_rectangle(crow,ccol+2);
	 clean_rectangle(crow+1,ccol+1);
	 return(true);

     case 14:
         if(body[crow][ccol]+body[crow+1][ccol]+body[crow+2][ccol]+
	    body[crow+1][ccol-1]!=4)
	     return(false);

	 body[crow][ccol]=0,body[crow+1][ccol]=0,body[crow+2][ccol]=0,body[crow+1][ccol-1]=0;
	 clean_rectangle(crow,ccol);
	 clean_rectangle(crow+1,ccol);
	 clean_rectangle(crow+2,ccol);
	 clean_rectangle(crow+1,ccol-1);
	 return(true);

     case 15:
         if(body[crow][ccol]+body[crow][ccol+1]+body[crow+1][ccol]+
	    body[crow+1][ccol+1]!=4)
	     return(false);

	 body[crow][ccol]=0,body[crow][ccol+1]=0,body[crow+1][ccol]=0,body[crow+1][ccol+1]=0;
	 clean_rectangle(crow,ccol);
	 clean_rectangle(crow,ccol+1);
	 clean_rectangle(crow+1,ccol);
	 clean_rectangle(crow+1,ccol+1);
	 return(true);

     case 16:
         if(body[crow][ccol]+body[crow+1][ccol]+body[crow+1][ccol+1]+
	    body[crow+2][ccol+1]!=4)
	     return(false);

	 body[crow][ccol]=0,body[crow+1][ccol]=0,body[crow+1][ccol+1]=0,body[crow+2][ccol+1]=0;
	 clean_rectangle(crow,ccol);
	 clean_rectangle(crow+1,ccol);
	 clean_rectangle(crow+1,ccol+1);
	 clean_rectangle(crow+2,ccol+1);
	 return(true);

     case 17:
         if(body[crow][ccol]+body[crow][ccol+1]+body[crow+1][ccol-1]+
	    body[crow+1][ccol]!=4)
	    return(false);

	 body[crow][ccol]=0,body[crow][ccol+1]=0,body[crow+1][ccol]=0,body[crow+1][ccol-1]=0;
	 clean_rectangle(crow,ccol);
	 clean_rectangle(crow,ccol+1);
	 clean_rectangle(crow+1,ccol-1);
	 clean_rectangle(crow+1,ccol);
	 return(true);

     case 18:
         if(body[crow][ccol]+body[crow+1][ccol]+body[crow][ccol+1]+
	    body[crow-1][ccol+1]!=4)
	    return(false);

	 body[crow][ccol]=0,body[crow+1][ccol]=0,body[crow][ccol+1]=0,body[crow-1][ccol+1]=0;
	 clean_rectangle(crow,ccol);
	 clean_rectangle(crow+1,ccol);
	 clean_rectangle(crow,ccol+1);
	 clean_rectangle(crow-1,ccol+1);
	 return(true);

     case 19:
         if(body[crow][ccol]+body[crow][ccol+1]+body[crow+1][ccol+2]+
	    body[crow+1][ccol+1]!=4)
	    return(false);

	 body[crow][ccol]=0,body[crow][ccol+1]=0,body[crow+1][ccol+2]=0,body[crow+1][ccol+1]=0;
	 clean_rectangle(crow,ccol);
	 clean_rectangle(crow,ccol+1);
	 clean_rectangle(crow+1,ccol+2);
	 clean_rectangle(crow+1,ccol+1);
	 return(true);

     default:return(false);

  }
}

bool test(int shape,int crow,int ccol) /*жָܷλʾָͼ*/
{
 switch(shape)
  {
    case 1:
	 if(body[crow][ccol]+body[crow][ccol+1]+body[crow][ccol+2]+
	    body[crow][ccol+3]>=1)
           return(false);

	 else
	 return(true);

     case 2:
         if(body[crow][ccol]+body[crow+1][ccol]+body[crow+2][ccol]+
	    body[crow+3][ccol]>=1)
           return(false);
         else
	 return(true);

     case 3:
         if(body[crow][ccol]+body[crow+1][ccol]+body[crow+1][ccol+1]+
	    body[crow+1][ccol+2]>=1)
          return(false);

	else
	 return(true);

     case 4:
         if(body[crow][ccol]+body[crow][ccol+1]+body[crow+1][ccol]+
	    body[crow+2][ccol]>=1)
          return(false);

	 else
	 return(true);

     case 5:
         if(body[crow][ccol]+body[crow][ccol+1]+body[crow][ccol+2]+
	    body[crow+1][ccol+2]>=1)
           return(false);


	 else
	 return(true);

     case 6:
         if(body[crow][ccol]+body[crow+1][ccol]+body[crow+2][ccol]+
	    body[crow+2][ccol-1]>=1)
	    return(false);

	 else
	 return(true);

     case 7:
         if(body[crow][ccol]+body[crow][ccol+1]+body[crow][ccol+2]+
	    body[crow-1][ccol+2]>=1)
	  return(false);

	 else
	 return(true);

     case 10:
         if(body[crow][ccol]+body[crow][ccol+1]+body[crow+1][ccol+1]+
	    body[crow+2][ccol+1]>=1)
	       return(false);

	 else
	 return(true);

     case 9:
         if(body[crow][ccol]+body[crow][ccol+1]+body[crow][ccol+2]+
	    body[crow+1][ccol]>=1)
	  return(false);

	 else
	 return(true);

     case 8:
         if(body[crow][ccol]+body[crow+1][ccol]+body[crow+2][ccol]+
	    body[crow+2][ccol+1]>=1)
	     return(false);

	else
	 return(true);

     case 11:
         if(body[crow][ccol]+body[crow+1][ccol]+body[crow+1][ccol+1]+
	    body[crow+1][ccol-1]>=1)
	     return(false);

	 else
	 return(true);

     case 12:
         if(body[crow][ccol]+body[crow+1][ccol]+body[crow+1][ccol+1]+
	    body[crow+2][ccol]>=1)
	     return(false);

	 else
	 return(true);

     case 13:
         if(body[crow][ccol]+body[crow][ccol+1]+body[crow][ccol+2]+
	    body[crow+1][ccol+1]>=1)
	    return(false);

	 else
	 return(true);

     case 14:
         if(body[crow][ccol]+body[crow+1][ccol]+body[crow+2][ccol]+
	    body[crow+1][ccol-1]>=1)
	     return(false);

	else
	 return(true);

     case 15:
         if(body[crow][ccol]+body[crow][ccol+1]+body[crow+1][ccol]+
	    body[crow+1][ccol+1]>=1)
	     return(false);

	else
	 return(true);

     case 16:
         if(body[crow][ccol]+body[crow+1][ccol]+body[crow+1][ccol+1]+
	    body[crow+2][ccol+1]>=1)
	     return(false);
	else
	 return(true);

     case 17:
         if(body[crow][ccol]+body[crow][ccol+1]+body[crow+1][ccol-1]+
	    body[crow+1][ccol]>=1)
	     return(false);

	else
	 return(true);

     case 18:
         if(body[crow][ccol]+body[crow+1][ccol]+body[crow][ccol+1]+
	    body[crow-1][ccol+1]>=1)
	     return(false);

	else
	 return(true);

     case 19:
         if(body[crow][ccol]+body[crow][ccol+1]+body[crow+1][ccol+2]+
	    body[crow+1][ccol+1]>=1)
	     return(false);

	else
	 return(true);

     default:return(false);

  }
}

bool draw_next(int c1,int c2,int c3,int c4)   /*úĸֵСڻĸ*/
{
 int row,col;
 int intBlackColor=BlackPixel(display,DefaultScreen(display));
XSetForeground(display,gc,intBlackColor);
 if(c1>16|c2>16|c3>16|c4>16) return(false);   /*д16ķFAILED*/
 row=(int)((c1-1)/4);
 col=c1-4*row;
XFillRectangle(display,win,gc,20*col+320,20*row+60,19,19);
 row=(int)((c2-1)/4);
 col=c2-4*row;
XFillRectangle(display,win,gc,20*col+320,20*row+60,19,19);
 row=(int)((c3-1)/4);
 col=c3-4*row;
XFillRectangle(display,win,gc,20*col+320,20*row+60,19,19);
 row=(int)((c4-1)/4);
 col=c4-4*row;
XFillRectangle(display,win,gc,20*col+320,20*row+60,19,19);
 return(true);
}

void viewnext(int shape)  /*ָ״NEXTСڻһֵķ*/
{
	int intWhiteColor=WhitePixel(display,DefaultScreen(display));
	XSetForeground(display,gc,intWhiteColor);
	XFillRectangle(display,win,gc,340,60,80,80);
 switch(shape)
  {
   case 1: draw_next(5,6,7,8);break;
   case 2: draw_next(2,6,10,14);break;
   case 3: draw_next(6,10,11,12);break;
   case 4: draw_next(6,7,10,14);break;
   case 5: draw_next(5,6,7,11);break;
   case 6: draw_next(3,7,11,10);break;
   case 7: draw_next(9,10,11,7);break;
   case 8: draw_next(2,6,10,11);break;
   case 9: draw_next(6,7,8,10);break;
   case 10: draw_next(6,7,11,15);break;
   case 11: draw_next(6,9,10,11);break;
   case 12: draw_next(2,6,10,7);break;
   case 13: draw_next(5,6,7,10);break;
   case 14: draw_next(3,7,11,6);break;
   case 15: draw_next(6,7,10,11);break;
   case 16: draw_next(6,10,11,15);break;
   case 17: draw_next(6,7,9,10);break;
   case 18: draw_next(3,7,6,10);break;
   case 19: draw_next(5,6,10,11);break;
   default:break;
  }
}

void kill(int row) /*ָУһ*/
{
 int i,x;
 for(i=15;i>=1;i--)
  {
   body[row][i]=0;
   clean_rectangle(row,i);
  }
 for(x=row;x>1;x--)
  for(i=1;i<=15;i++)
   {
    if(body[x-1][i]==1)
     {
       body[x][i]=1;
       draw_rectangle(x,i);
       body[x-1][i]=0;
       clean_rectangle(x-1,i);
     }
   }
}

int AddMark(void) /*жǷûз0򷵻KILL()*/
{
 int i=0,j=0,m=0,n=0;
 for(i=1;i<=25;i++)
  {
   n=0;
   for(j=1;j<=15;j++)
     n=n+body[i][j];
   if(n==15)
      {
       m++;
       kill(i);
      }
   }
 return(m);
}
